<template>
    <div class="subscription">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.SUBSCRIPTIONEDIT') }}
                        </h1>
                        <v-breadcrumbs
                            ><v-breadcrumbs-item
                                class="text-red pointer"
                                @click="goToPage(menus.SUBSCRIPTION.id)"
                                >{{
                                    $t('dashboard.menu.SUBSCRIPTION')
                                }}</v-breadcrumbs-item
                            ><v-breadcrumbs-divider>/</v-breadcrumbs-divider>
                            <v-breadcrumbs-item disabled>{{
                                $t('dashboard.menu.SUBSCRIPTIONEDIT')
                            }}</v-breadcrumbs-item></v-breadcrumbs
                        >
                    </v-col>
                </v-row>
                <v-form
                    v-show="pageLoaded"
                    ref="subscribeForm"
                    lazy-validation
                    @submit.prevent
                >
                    <!-- CURRENT PLAN -->
                    <v-row
                        :class="[
                            {
                                'pl-0 pr-0': $vuetify.breakpoint.smAndDown,
                            },
                            {
                                'pl-16 pr-16': $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <!-- CURRENT PLAN -->
                        <v-col>
                            <h3 class="font-syne-bold highlight-text">
                                {{ $t('dashboard.currentPlan') }}
                            </h3>
                            <v-row class="pt-5">
                                <v-col>
                                    <h3
                                        v-if="planDetails"
                                        class="font-syne-bold mb-0 text-white"
                                    >
                                        {{ planDetails.name }}
                                    </h3>

                                    <h3
                                        v-if="planDetails"
                                        class="font-syne-bold price text-white"
                                    >
                                        {{ currencyName }}
                                        {{ planDetails.amount }}
                                        <span class="duration"
                                            >{{ planDetails.amount ? '/' : ''
                                            }}{{ planDetails.interval }}</span
                                        >
                                    </h3>
                                    <div
                                        v-if="planDetails"
                                        class="mt-5 mb-5"
                                        v-html="planDetails.description"
                                    ></div>
                                </v-col>
                            </v-row>
                        </v-col>

                        <!-- UPGRADE PLAN -->
                        <v-col>
                            <h3 class="font-syne-bold highlight-text">
                                {{ $t('dashboard.editSubscription') }}
                            </h3>
                            <v-row class="pt-5">
                                <!-- SHOW LOADER -->
                                <v-col v-if="plans.length === 0" cols="12">
                                    <v-row>
                                        <v-col
                                            v-for="n in 2"
                                            :key="'loader-' + n"
                                            cols="6"
                                        >
                                            <v-skeleton-loader
                                                class="pt-2"
                                                :loading="dataLoading"
                                                max-width="150"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="100"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="120"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="100"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="100"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="100"
                                                type="text"
                                            />

                                            <v-skeleton-loader
                                                :loading="dataLoading"
                                                max-width="100"
                                                type="text"
                                            />
                                        </v-col>
                                    </v-row>
                                </v-col>
                                <v-col v-else>
                                    <v-row
                                        v-for="(plan, p) in plans"
                                        :key="'plan-' + p"
                                    >
                                        <v-col
                                            md="12"
                                            cols="12"
                                            class="font-metropolis-regular pt-0 mb-5 pointer"
                                            :class="{
                                                'border-selected':
                                                    selectedPlan ==
                                                    plan.stripe_plan,
                                            }"
                                            @click="setSelectedPlanAmount(plan)"
                                        >
                                            <h3
                                                class="font-syne-bold mb-0 text-white"
                                            >
                                                {{ plan.name }}
                                            </h3>

                                            <h3
                                                class="font-syne-bold price text-white"
                                            >
                                                {{ currencyName }}
                                                {{ plan.amount }}
                                                <span class="duration"
                                                    >/{{ plan.interval }}</span
                                                >
                                            </h3>
                                            <div
                                                class="mt-5 mb-5"
                                                v-html="plan.description"
                                            ></div>
                                        </v-col>
                                    </v-row>
                                    <!-- <v-radio-group
                                        v-model="selectedPlan"
                                        row
                                        :rules="[requiredRules]"
                                    >
                                        <v-row
                                            v-for="(plan, p) in plans"
                                            :key="'plan-' + p"
                                        >
                                            <v-radio
                                                :key="'radio-plan-' + p"
                                                :value="plan.stripe_plan"
                                                color="badge"
                                                @change="
                                                    setSelectedPlanAmount(plan)
                                                "
                                            >
                                                <template v-slot:label>
                                                    <v-col
                                                        md="12"
                                                        cols="12"
                                                        class="form-field font-metropolis-regular"
                                                    >
                                                        <h3
                                                            class="font-syne-bold mb-0 text-white"
                                                        >
                                                            {{ plan.name }}
                                                        </h3>

                                                        <h3
                                                            class="font-syne-bold price text-white"
                                                        >
                                                            {{ currencyName }}
                                                            {{ plan.amount }}
                                                            <span
                                                                class="duration"
                                                                >/{{
                                                                    plan.interval
                                                                }}</span
                                                            >
                                                        </h3>
                                                        <div
                                                            class="mt-5 mb-5"
                                                            v-html="
                                                                plan.description
                                                            "
                                                        ></div>
                                                    </v-col>
                                                </template>
                                            </v-radio>
                                        </v-row>
                                    </v-radio-group> -->
                                </v-col>
                                <v-col
                                    v-if="plans.length > 0"
                                    cols="12"
                                    class="pa-0"
                                >
                                    <v-btn
                                        :block="$vuetify.breakpoint.smAndDown"
                                        class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                        color="badge"
                                        :loading="isButtonDisabled"
                                        :disabled="isButtonDisabled"
                                        @click="validateForm"
                                        >{{
                                            $t('buttons.updatePlanBtn')
                                        }}</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-form>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.SUBSCRIPTIONEDIT'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        planName: 'subscription/getPlan',
        planDetails: 'subscription/getPlanDetails',
        currencyName: 'currency/getCurrencyName',
    }),
})
export default class PaymentEdit extends Vue {
    // Data
    $refs!: { subscribeForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    menus!: any
    selectedPage: number = 4 // subscription
    selectedPlan: string = ''
    selectedPlanDetails!: any
    selectedPlanAmount!: number
    planName!: string
    planDetails!: any
    isButtonDisabled = false
    dataLoading: boolean = true
    formHasErrors: boolean = false
    plans: any = []

    // Rules
    requiredRules(v: any) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    // Methods
    async getPlans() {
        const getPlans = await this.$api.plan.plans()
        if (getPlans) {
            this.plans = getPlans.data.data.filter(
                (plan) => plan.stripe_plan !== this.planDetails.stripe_plan
            )
        }
    }

    goToPage(id: Number) {
        switch (id) {
            case this.menus.SUBSCRIPTION.id:
                this.$router.push(this.menus.SUBSCRIPTION.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.subscribeForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    setSelectedPlanAmount(plan: any) {
        this.selectedPlan = plan.stripe_plan
        this.selectedPlanDetails = plan
        this.selectedPlanAmount = plan.amount
    }

    submit() {
        this.isButtonDisabled = true

        if (this.planDetails.amount < this.selectedPlanAmount) {
            // Upgrade plan
            this.$api.subscription
                .upgrade(this.selectedPlan)
                .then((response) => {
                    if (response) {
                        // Update new plan at store
                        this.$store.dispatch(
                            'subscription/setUpdatePlan',
                            this.selectedPlanDetails
                        )

                        // Display snackbar message
                        const val = {
                            text: this.$t('notification.subscription.upgrade'),
                            color: 'green',
                            icon: 'mdi-check',
                        }
                        this.$store.dispatch('snackbar/displaySnackBar', val)

                        // Reopen button
                        this.isButtonDisabled = false

                        // Redirect to subscription page
                        this.$router.push(this.menus.SUBSCRIPTION.path)
                    }
                })
                .catch((error) => {
                    let errorVal

                    if (error.response.status === 401) {
                        errorVal = {
                            text: this.$t('notification.subscription.invalid'),
                            color: 'red',
                            icon: 'mdi-close-circle',
                        }
                    }

                    if (error.response.status === 422) {
                        errorVal = {
                            text: this.$t(
                                'notification.subscription.selectRequired'
                            ),
                            color: 'red',
                            icon: 'mdi-close-circle',
                        }
                    }

                    this.$store.dispatch('snackbar/displaySnackBar', errorVal)

                    // Reopen button
                    this.isButtonDisabled = false
                })
        } else {
            // Downgrade plan
            this.$api.subscription
                .downgrade(this.selectedPlan)
                .then((response) => {
                    if (response) {
                        // Update new plan at store
                        this.$store.dispatch(
                            'subscription/setUpdatePlan',
                            this.selectedPlanDetails
                        )

                        // Display snackbar message
                        const val = {
                            text: this.$t(
                                'notification.subscription.downgrade'
                            ),
                            color: 'green',
                            icon: 'mdi-check',
                        }
                        this.$store.dispatch('snackbar/displaySnackBar', val)

                        // Reopen button
                        this.isButtonDisabled = false

                        // Redirect to subscription page
                        this.$router.push(this.menus.SUBSCRIPTION.path)
                    }
                })
                .catch((error) => {
                    let errorVal
                    if (error.response.status === 401) {
                        errorVal = {
                            text: this.$t('notification.subscription.invalid'),
                            color: 'red',
                            icon: 'mdi-close-circle',
                        }
                    }

                    if (error.response.status === 422) {
                        errorVal = {
                            text: this.$t(
                                'notification.subscription.selectRequired'
                            ),
                            color: 'red',
                            icon: 'mdi-close-circle',
                        }
                    }

                    this.$store.dispatch('snackbar/displaySnackBar', errorVal)

                    // Reopen button
                    this.isButtonDisabled = false
                })
        }
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
        // Get plans list
        this.getPlans()
    }
}
</script>
